org.apache.felix.deploymentadmin

## Class StreamDeploymentPackage

- java.lang.Object
- - org.apache.felix.deploymentadmin.AbstractDeploymentPackage
  - - org.apache.felix.deploymentadmin.StreamDeploymentPackage

All Implemented Interfaces:
  org.osgi.framework.Constants, org.osgi.service.deploymentadmin.DeploymentPackage

    public class StreamDeploymentPackage
    extends AbstractDeploymentPackage

This class represents a deployment package that is read from a jar stream.

### Field Summary

### Fields inherited from class org.apache.felix.deploymentadmin.AbstractDeploymentPackage

`EMPTY_PACKAGE`

### Fields inherited from interface org.osgi.service.deploymentadmin.DeploymentPackage

`EVENT_DEPLOYMENTPACKAGE_CURRENTVERSION, EVENT_DEPLOYMENTPACKAGE_NAME, EVENT_DEPLOYMENTPACKAGE_NEXTVERSION, EVENT_DEPLOYMENTPACKAGE_READABLENAME`

### Fields inherited from interface org.apache.felix.deploymentadmin.Constants

`BUNDLE_LOCATION_PREFIX, BUNDLE_SYMBOLICNAME, BUNDLE_VERSION, CODE_BAD_HEADER, CODE_BUNDLE_NAME_ERROR, CODE_BUNDLE_SHARING_VIOLATION, CODE_CANCELLED, CODE_COMMIT_ERROR, CODE_FOREIGN_CUSTOMIZER, CODE_MISSING_BUNDLE, CODE_MISSING_FIXPACK_TARGET, CODE_MISSING_HEADER, CODE_MISSING_RESOURCE, CODE_NOT_A_JAR, CODE_ORDER_ERROR, CODE_OTHER_ERROR, CODE_PROCESSOR_NOT_FOUND, CODE_RESOURCE_SHARING_VIOLATION, CODE_SIGNING_ERROR, CODE_TIMEOUT, DEPLOYMENTPACKAGE_CUSTOMIZER, DEPLOYMENTPACKAGE_FIXPACK, DEPLOYMENTPACKAGE_ICON, DEPLOYMENTPACKAGE_MISSING, DEPLOYMENTPACKAGE_NAME, DEPLOYMENTPACKAGE_SYMBOLICMAME, DEPLOYMENTPACKAGE_VERSION, EVENTPROPERTY_DEPLOYMENTPACKAGE_CURRENTVERSION, EVENTPROPERTY_DEPLOYMENTPACKAGE_NAME, EVENTPROPERTY_DEPLOYMENTPACKAGE_NEXTVERSION, EVENTPROPERTY_DEPLOYMENTPACKAGE_READABLENAME, EVENTPROPERTY_SUCCESSFUL, EVENTTOPIC_COMPLETE, EVENTTOPIC_INSTALL, EVENTTOPIC_UNINSTALL, RESOURCE_PROCESSOR, SERVICE_PID`

### Fields inherited from interface org.osgi.framework.Constants

`ACTIVATION_LAZY, BUNDLE_ACTIVATIONPOLICY, BUNDLE_ACTIVATOR, BUNDLE_CATEGORY, BUNDLE_CLASSPATH, BUNDLE_CONTACTADDRESS, BUNDLE_COPYRIGHT, BUNDLE_DESCRIPTION, BUNDLE_DOCURL, BUNDLE_LOCALIZATION, BUNDLE_LOCALIZATION_DEFAULT_BASENAME, BUNDLE_MANIFESTVERSION, BUNDLE_NAME, BUNDLE_NATIVECODE, BUNDLE_NATIVECODE_LANGUAGE, BUNDLE_NATIVECODE_OSNAME, BUNDLE_NATIVECODE_OSVERSION, BUNDLE_NATIVECODE_PROCESSOR, BUNDLE_REQUIREDEXECUTIONENVIRONMENT, BUNDLE_SYMBOLICNAME_ATTRIBUTE, BUNDLE_UPDATELOCATION, BUNDLE_VENDOR, BUNDLE_VERSION_ATTRIBUTE, DYNAMICIMPORT_PACKAGE, EXCLUDE_DIRECTIVE, EXPORT_PACKAGE, EXPORT_SERVICE, EXTENSION_BOOTCLASSPATH, EXTENSION_DIRECTIVE, EXTENSION_FRAMEWORK, FRAGMENT_ATTACHMENT_ALWAYS, FRAGMENT_ATTACHMENT_DIRECTIVE, FRAGMENT_ATTACHMENT_NEVER, FRAGMENT_ATTACHMENT_RESOLVETIME, FRAGMENT_HOST, FRAMEWORK_BEGINNING_STARTLEVEL, FRAMEWORK_BOOTDELEGATION, FRAMEWORK_BUNDLE_PARENT, FRAMEWORK_BUNDLE_PARENT_APP, FRAMEWORK_BUNDLE_PARENT_BOOT, FRAMEWORK_BUNDLE_PARENT_EXT, FRAMEWORK_BUNDLE_PARENT_FRAMEWORK, FRAMEWORK_EXECPERMISSION, FRAMEWORK_EXECUTIONENVIRONMENT, FRAMEWORK_LANGUAGE, FRAMEWORK_LIBRARY_EXTENSIONS, FRAMEWORK_OS_NAME, FRAMEWORK_OS_VERSION, FRAMEWORK_PROCESSOR, FRAMEWORK_SECURITY, FRAMEWORK_SECURITY_OSGI, FRAMEWORK_STORAGE, FRAMEWORK_STORAGE_CLEAN, FRAMEWORK_STORAGE_CLEAN_ONFIRSTINIT, FRAMEWORK_SYSTEMPACKAGES, FRAMEWORK_SYSTEMPACKAGES_EXTRA, FRAMEWORK_TRUST_REPOSITORIES, FRAMEWORK_VENDOR, FRAMEWORK_VERSION, FRAMEWORK_WINDOWSYSTEM, IMPORT_PACKAGE, IMPORT_SERVICE, INCLUDE_DIRECTIVE, MANDATORY_DIRECTIVE, OBJECTCLASS, PACKAGE_SPECIFICATION_VERSION, REQUIRE_BUNDLE, RESOLUTION_DIRECTIVE, RESOLUTION_MANDATORY, RESOLUTION_OPTIONAL, SELECTION_FILTER_ATTRIBUTE, SERVICE_DESCRIPTION, SERVICE_ID, SERVICE_RANKING, SERVICE_VENDOR, SINGLETON_DIRECTIVE, SUPPORTS_BOOTCLASSPATH_EXTENSION, SUPPORTS_FRAMEWORK_EXTENSION, SUPPORTS_FRAMEWORK_FRAGMENT, SUPPORTS_FRAMEWORK_REQUIREBUNDLE, SYSTEM_BUNDLE_LOCATION, SYSTEM_BUNDLE_SYMBOLICNAME, USES_DIRECTIVE, VERSION_ATTRIBUTE, VISIBILITY_DIRECTIVE, VISIBILITY_PRIVATE, VISIBILITY_REEXPORT`

### Constructor Summary

Constructors
Constructor and Description
`StreamDeploymentPackage(JarInputStream input, org.osgi.framework.BundleContext bundleContext, DeploymentAdminImpl deploymentAdmin)` Creates an instance of this class.

### Method Summary

All Methods Instance Methods Concrete Methods
`InputStream` `getBundleStream(String symbolicName)` Determines the data stream of a bundle resource based on the bundle symbolic name
`InputStream` `getCurrentEntryStream()` Determines the data stream to the current entry of this deployment package, use this together with the `getNextEntry` method.
`AbstractInfo` `getNextEntry()` Determines the next resource entry in this deployment package based on the order in which the resources appeared when the package was originally received.
`BundleInfoImpl[]` `getOrderedBundleInfos()` Determines the bundles of this deployment package in the order in which they were originally received.
`ResourceInfoImpl[]` `getOrderedResourceInfos()` Determines the resources of this deployment package in the order in which they were originally received.

### Methods inherited from class org.apache.felix.deploymentadmin.AbstractDeploymentPackage

`getAbstractInfoByPath, getBundle, getBundleInfoByName, getBundleInfoByPath, getBundleInfoImpls, getBundleInfos, getDisplayName, getHeader, getIcon, getName, getResourceHeader, getResourceInfoByPath, getResourceInfos, getResourceProcessor, getResources, getVersion, getVersionRange, isFixPackage, isMetaInfFile, isNew, isStale, setStale, uninstall, uninstallForced`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.osgi.service.deploymentadmin.DeploymentPackage

`equals, hashCode`

### Constructor Detail

#### StreamDeploymentPackage

    public StreamDeploymentPackage(JarInputStream input,
                                   org.osgi.framework.BundleContext bundleContext,
                                   DeploymentAdminImpl deploymentAdmin)
                            throws org.osgi.service.deploymentadmin.DeploymentException

Creates an instance of this class.

Parameters:
  `input` - The stream from which the deployment package can be read.
  `bundleContext` - The bundle context.
Throws:
  `org.osgi.service.deploymentadmin.DeploymentException` - If it was not possible to read a valid deployment package from the specified stream.

### Method Detail

#### getBundleStream

    public InputStream getBundleStream(String symbolicName)

Description copied from class: `AbstractDeploymentPackage`
Determines the data stream of a bundle resource based on the bundle symbolic name

Specified by:
  `getBundleStream` in class `AbstractDeploymentPackage`
Parameters:
  `symbolicName` - Bundle symbolic name
Returns:
  Stream to the bundle identified by the specified symbolic name or null if no such bundle exists in this deployment package.

#### getCurrentEntryStream

    public InputStream getCurrentEntryStream()

Description copied from class: `AbstractDeploymentPackage`
Determines the data stream to the current entry of this deployment package, use this together with the `getNextEntry` method.

Specified by:
  `getCurrentEntryStream` in class `AbstractDeploymentPackage`
Returns:
  Stream to the current resource in the deployment package (as determined by the order in which the deployment package was received originally) or null if there is no entry

#### getNextEntry

    public AbstractInfo getNextEntry()
                              throws IOException

Description copied from class: `AbstractDeploymentPackage`
Determines the next resource entry in this deployment package based on the order in which the resources appeared when the package was originally received.

Specified by:
  `getNextEntry` in class `AbstractDeploymentPackage`
Returns:
  `AbstractInfo` describing the next resource entry (as determined by the order in which the deployment package was received originally) or null if there is no next entry
Throws:
  `IOException` - if the next entry can not be properly determined

#### getOrderedBundleInfos

    public BundleInfoImpl[] getOrderedBundleInfos()

Description copied from class: `AbstractDeploymentPackage`
Determines the bundles of this deployment package in the order in which they were originally received.

Specified by:
  `getOrderedBundleInfos` in class `AbstractDeploymentPackage`
Returns:
  Array containing `BundleInfoImpl` objects of the bundles in this deployment package, ordered in the way they appeared when the deployment package was first received.

#### getOrderedResourceInfos

    public ResourceInfoImpl[] getOrderedResourceInfos()

Description copied from class: `AbstractDeploymentPackage`
Determines the resources of this deployment package in the order in which they were originally received.

Specified by:
  `getOrderedResourceInfos` in class `AbstractDeploymentPackage`
Returns:
  Array containing `ResourceInfoImpl` objects of all processed resources in this deployment package, ordered in the way they appeared when the deployment package was first received